#!/bin/bash

go build
$(cd ../cmd/burntsushi-tester/; go build)

DURATION=`./parse2 -p 10 < long.toml 2>&1 | grep Duration | awk '{print $2}'`
echo "$DURATION parse2 10 iteration profiling of long.toml"

DURATION=`./parse2 -p 1000 < normal.toml 2>&1 | grep Duration | awk '{print $2}'`
echo "$DURATION parse2 1000 iteration profiling of normal.toml"

echo ""

DURATION=`../cmd/burntsushi-tester/burntsushi-tester -p 10 < long.toml 2>&1 | grep Duration | awk '{print $2}'`
echo "$DURATION burntsushi-tester 10 iteration profiling of long.toml"

DURATION=`../cmd/burntsushi-tester/burntsushi-tester -p 1000 < normal.toml 2>&1 | grep Duration | awk '{print $2}'`
echo "$DURATION burntsushi-tester 1000 iteration profiling of normal.toml"

echo ""

(cd ..; make test) | awk '{print $3 " " $2 " (unit tests)"}'

echo ""

DURATION=`(cd ..; make test-sushi) 2>&1 | grep real | awk '{print $2}'`
echo $DURATION BurntSushi test set

echo ""

for F in ../parse/testfiles/valid/*/qa-*.toml; do
	FILE=`basename $F`
	DURATION=`cat $F | ./parse2 -p 1 2>&1 | grep Duration | awk '{print $2}'`
        echo $DURATION $FILE
done
